/*
 *  This file is part of Klint
 *  Copyright (C) 2001 Roberto Raggi (roberto@kdevelop.org)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to
 *  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *
 */

#ifndef cpp_colorizer_h
#define cpp_colorizer_h

#include "qsourcecolorizer.h"
#include <Qt3Support>
#include <QtGui>
#include <QtCore>

namespace qrs {

class CppColorizer: public QSourceColorizer{
public:
    CppColorizer( QEditor* );
    virtual ~CppColorizer();

    int computeLevel( Q3TextParagraph* parag, int startLevel );

private:
    void loadDynamicKeywords();

private:
    QMap<QString, int> m_dynamicKeywords;
};

}
#endif
