#include "general_defs.h"
#ifndef ROSE_FORTRAN_TOKEN_DEFS
#define ROSE_FORTRAN_TOKEN_DEFS 1
//
//Yes the values to the enums can be "cool" hex numbers. 
//very similar to the one offered in WAVE.
//The conversion can be done later.
//the scripts are in place.
//
enum ROSE_Fortran_Identifiers
{
      ROSE_ABSTRACT = 2, 
      ROSE_ACCESS = 3, 
      ROSE_ACTION = 4, 
      ROSE_ALLOCATE = 5,       
      ROSE_ALLOCATABLE = 6,    
      ROSE_ASSIGN = 7,         
      ROSE_ASSOCIATE = 8, 
      ROSE_ASYNCHRONOUS = 9,   
      ROSE_BACKSPACE = 10,      
      ROSE_BIND = 11,           
      ROSE_BLANK = 12,         
      ROSE_BLOCK_DATA = 13,     
      ROSE_CALL = 14,           
      ROSE_CHARACTER = 15, 
      ROSE_CLASS = 16,
      ROSE_CLOSE = 17,          
      ROSE_CONTINUE = 18,       
      ROSE_CYCLE = 19,          
      ROSE_CASE = 20,           
      ROSE_COMMON = 21,         
      ROSE_COMPLEX = 22,
      ROSE_CONTAINS = 23,       
      ROSE_DEALLOCATE = 24,     
      ROSE_DATA = 25,           
      ROSE_DEFERRED = 26,  
      ROSE_DELIM = 27,  
      ROSE_DIMENSION = 28,      
      ROSE_DO = 29,
      ROSE_DT = 30,
      ROSE_DOUBLEPRECISION = 31,
      ROSE_ENCODING = 32,       
      ROSE_END_CASE = 33,       
      ROSE_ENDDO = 34,          
      ROSE_END_FILE = 35,       
      ROSE_END_ENUM = 36, 
      ROSE_END_INTERFACE = 37, 
      ROSE_END_TYPE = 38, 
      ROSE_ERR = 39, 
      ROSE_ERRMSG = 40, 
      ROSE_EXIT = 41,           
      ROSE_ELSE = 42,           
      ROSE_ELSEWHERE = 43,      
      ROSE_ELSEIF = 44,         
      ROSE_ENDIF = 45,
      ROSE_ENTRY = 46,          
      ROSE_END = 47,
      ROSE_ENUM = 47,           
      ROSE_ENUMERATOR = 49,     
      ROSE_EQUIVALENCE = 50,    
      ROSE_EXTERNAL = 51,       
      ROSE_EXTENDS = 52, 
      ROSE_FILE = 53, 
      ROSE_FINAL = 54,          
      ROSE_FMT = 55,            
      ROSE_FORALL = 56,         
      ROSE_FORM = 57,  
      ROSE_FORMATTED = 58,  
      ROSE_FORMAT = 59,         
      ROSE_FLUSH = 60,          
      ROSE_FUNCTION = 61,       
      ROSE_GENERIC = 62,        
      ROSE_GOTO = 63,           
      ROSE_ID = 64,             
      ROSE_IF = 65,             
      ROSE_INQUIRE = 66,        
      ROSE_INTEGER = 67,        
      ROSE_IOMSG = 68, 
      ROSE_IOSTAT = 69, 
      ROSE_IMPLICIT = 70,       
      ROSE_IMPLICIT_NONE = 71,  
      ROSE_IMPORT = 72,         
      ROSE_INTERFACE = 73,      
      ROSE_INTENT = 74,         
      ROSE_INTRINSIC = 75,      
      ROSE_LEN = 76,         
      ROSE_LOGICAL = 77,        
      ROSE_KIND = 78, 
      ROSE_MODULE_PROC = 79,    
      ROSE_MODULE = 80,         
      ROSE_NON_INTRINSIC = 81,  
      ROSE_NON_OVERRIDABLE = 82,
      ROSE_NULL = 83,
      ROSE_NULLIFY = 84,        
      ROSE_NAMELIST = 85,       
      ROSE_NML = 86,
      ROSE_NONE = 87,           
      ROSE_NOPASS = 88,  
      ROSE_ONLY = 89,           
      ROSE_OPEN = 90,           
      ROSE_OPTIONAL = 90,       
      ROSE_PARAMETER = 91,      
      ROSE_PASS = 92, 
      ROSE_PAUSE = 93,          
      ROSE_POINTER = 94,        
      ROSE_PRINT = 96,          
      ROSE_PRIVATE = 97,        
      ROSE_PROCEDURE = 98,      
      ROSE_PROGRAM = 99,        
      ROSE_PROTECTED = 100,      
      ROSE_READ = 101,           
      ROSE_REAL = 102, 
      ROSE_RETURN = 103,         
      ROSE_REWIND = 104,         
      ROSE_ROUND = 105,  
      ROSE_SELECTCASE = 106, 
      ROSE_SELECTTYPE = 107, 
      ROSE_SEQUENCE = 108,       
      ROSE_SAVE = 109,           
      ROSE_SIGN = 110, 
      ROSE_SIZE = 111, 
      ROSE_SOURCE = 112,         
      ROSE_STAT = 113, 
      ROSE_STOP = 114,           
      ROSE_SUBROUTINE = 115,
      ROSE_TARGET = 116,         
      ROSE_THEN = 117, 
      ROSE_DERIVED_DECL = 118,   
      ROSE_TYPEIS = 119, 
      ROSE_UNFORMATTED = 120, 
      ROSE_UNIT = 121, 
      ROSE_USE = 122,            
      ROSE_VALUE = 123,          
      ROSE_VOLATILE = 124,       
      ROSE_WAIT = 125,           
      ROSE_WHERE = 126,
      ROSE_WRITE = 127
};

enum ROSE_Fortran_Operators
{
      ROSE_INTRINSIC_PLUS = 1001,  
      ROSE_INTRINSIC_MINUS = 1002,
      ROSE_INTRINSIC_POWER = 1003,
      ROSE_INTRINSIC_CONCAT = 1004,
      ROSE_INTRINSIC_TIMES = 1005,
      ROSE_INTRINSIC_DIVIDE = 1006,
      ROSE_INTRINSIC_AND = 1007,  
      ROSE_INTRINSIC_OR = 1008,   
      ROSE_INTRINSIC_EQV = 1009,  
      ROSE_INTRINSIC_NEQV = 1010, 
      ROSE_INTRINSIC_EQ = 1011,  
      ROSE_INTRINSIC_NE = 1012,  
      ROSE_INTRINSIC_GE = 1013,   
      ROSE_INTRINSIC_LE = 1014,   
      ROSE_INTRINSIC_LT = 1015,   
      ROSE_INTRINSIC_GT = 1016,   
      ROSE_INTRINSIC_NOT = 1017,  
      ROSE_INTRINSIC_OLDEQ = 1018,
      ROSE_INTRINSIC_OLDNE = 1019,
      ROSE_INTRINSIC_OLDGE = 1020,
      ROSE_INTRINSIC_OLDLE = 1021,
      ROSE_INTRINSIC_OLDLT = 1022,
      ROSE_INTRINSIC_OLDGT = 1023,
};

enum ROSE_Fortran_Additional_Info
{
      ROSE_FORT_COMMENTS = 10001,
      ROSE_STRING_LITERALS = 10002,
      ROSE_IDENTIFIER = 10003
};
 
#endif
